open Interface;

let (>.) = Function.Infix.(>.);

module Conjunctive = {
  module Magma: MAGMA with type t = Belt.Set.Int.t = {
    type t = Belt.Set.Int.t;
    let append = Belt.Set.Int.union
  };
  module Medial_Magma: MEDIAL_MAGMA with type t = Belt.Set.Int.t = Magma;
  module Semigroup: SEMIGROUP with type t = Belt.Set.Int.t = { include Magma };
  module Monoid: MONOID with type t = Belt.Set.Int.t = {
    include Semigroup;
    let empty = Belt.Set.Int.empty
  }
};

module Eq: EQ with type t = Belt.Set.Int.t = {
  type t = Belt.Set.Int.t;
  let eq = Belt.Set.Int.eq
};

module Ord: ORD with type t = Belt.Set.Int.t = {
  include Eq;
  let compare = (a, b) => Belt.Set.Int.cmp(a, b) |> int_to_ordering
};

module Join_Semilattice: JOIN_SEMILATTICE with type t = Belt.Set.Int.t = {
  type t = Belt.Set.Int.t;
  let join = Belt.Set.Int.union
};


